Bug 186242 - CVE-2006-1343 Small information leak in SO_ORIGINAL_DST
CVE-2006-1343 Small information leak in SO_ORIGINAL_DST
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
medium Severity low
: ---
: ---
Assigned To: Thomas Graf
Brian Brock
: Security
Depends On:
Blocks: 181409
  Show dependency treegraph
Reported: 2006-03-22 09:48 EST by Marcel Holtmann
Modified: 2014-06-18 04:28 EDT (History)
4 users (show)

See Also:
Fixed In Version: RHSA-2006-0575
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-08-10 18:53:03 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Example code for showing the problem (1.66 KB, text/x-csrc)
2006-03-22 09:57 EST, Marcel Holtmann
no flags Details

  None (edit)
Description Marcel Holtmann 2006-03-22 09:48:37 EST
It appears sockaddr_in.sin_zero is not zeroed during certain operations
returning IPv4 socket names, namely:

- getsockopt(...SO_ORIGINAL_DST...) (2.4 and 2.6)
  see getorigdst() in net/ipv4/netfilter/ip_conntrack_core.c
  (+ in net/ipv4/netfilter/nf_conntrack_l3proto_ipv4.c in 2.6?!)

- getsockname() and getpeername() (and accept()) (2.4 only)
  see inet_getname() in net/ipv4/af_inet.c

and several unitialized bytes of kernel stack (sizeof(sin_zero) == 6 to be
precise) leak to the userspace.

Comment 1 Marcel Holtmann 2006-03-22 09:57:52 EST
Created attachment 126477 [details]
Example code for showing the problem
Comment 4 Jason Baron 2006-04-06 21:53:51 EDT
committed in stream U4 build 34.14. A test kernel with this patch is available
from http://people.redhat.com/~jbaron/rhel4/
Comment 5 Bob Johnson 2006-04-11 12:07:59 EDT
This issue is on Red Hat Engineering's list of planned work items 
for the upcoming Red Hat Enterprise Linux 4.4 release.  Engineering 
resources have been assigned and barring unforeseen circumstances, Red 
Hat intends to include this item in the 4.4 release.
Comment 8 Mike Gahagan 2006-07-14 15:44:11 EDT
looks to be fixed in 40.1.EL, same results as in 2.1

[mgahagan@dhcp59-204 bz186242]$ ./bug 2345
data: 02 00 89 e1 ac 10 3b ce 00 00 00 00 00 00 00 00
data: 02 00 09 29 ac 10 3b cc 00 00 00 00 00 00 00 00
getsockname(as): Protocol not available
Comment 10 Red Hat Bugzilla 2006-08-10 18:53:04 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.